dect
/
asterisk
Archived
13
0
Fork 0

Merged revisions 182810 via svnmerge from

https://origsvn.digium.com/svn/asterisk/branches/1.4

........
r182810 | russell | 2009-03-17 21:09:13 -0500 (Tue, 17 Mar 2009) | 44 lines

Fix cases where the internal poll() was not being used when it needed to be.

We have seen a number of problems caused by poll() not working properly on 
Mac OSX.  If you search around, you'll find a number of references to using 
select() instead of poll() to work around these issues.  In Asterisk, we've 
had poll.c which implements poll() using select() internally.  However, we 
were still getting reports of problems.

vadim investigated a bit and realized that at least on his system, even 
though we were compiling in poll.o, the system poll() was still being used.  
So, the primary purpose of this patch is to ensure that we're using the 
internal poll() when we want it to be used.

The changes are:

1) Remove logic for when internal poll should be used from the Makefile.  
   Instead, put it in the configure script.  The logic in the configure 
   script is the same as it was in the Makefile.  Ideally, we would have 
   a functionality test for the problem, but that's not actually possible, 
   since we would have to be able to run an application on the _target_ 
   system to test poll() behavior.

2) Always include poll.o in the build, but it will be empty if AST_POLL_COMPAT
   is not defined.

3) Change uses of poll() throughout the source tree to ast_poll().  I feel 
   that it is good practice to give the API call a new name when we are 
   changing its behavior and not using the system version directly in all cases.
   So, normally, ast_poll() is just redefined to poll().  On systems where 
   AST_POLL_COMPAT is defined, ast_poll() is redefined to ast_internal_poll().

4) Change poll() in main/poll.c to be ast_internal_poll().

It's worth noting that any code that still uses poll() directly will work fine 
(if they worked fine before).  So, for example, out of tree modules that are 
using poll() will not stop working or anything.  However, for modules to work 
properly on Mac OSX, ast_poll() needs to be used.

(closes issue #13404)
Reported by: agalbraith
Tested by: russell, vadim

http://reviewboard.digium.com/r/198/

........


git-svn-id: http://svn.digium.com/svn/asterisk/trunk@182847 f38db490-d61c-443f-a65b-d21fe96a405b
This commit is contained in:
russell 2009-03-18 02:28:55 +00:00
parent 870bfecfe6
commit b48669aa8f
17 changed files with 204 additions and 57 deletions

View File

@ -108,7 +108,7 @@ static int timed_read(int fd, void *data, int datalen, int timeout)
struct pollfd fds[1];
fds[0].fd = fd;
fds[0].events = POLLIN;
res = poll(fds, 1, timeout);
res = ast_poll(fds, 1, timeout);
if (res < 1) {
ast_log(LOG_NOTICE, "Poll timed out/errored out with %d\n", res);
return -1;

View File

@ -96,7 +96,7 @@ static int timed_read(int fd, void *data, int datalen)
struct pollfd fds[1];
fds[0].fd = fd;
fds[0].events = POLLIN;
res = poll(fds, 1, 2000);
res = ast_poll(fds, 1, 2000);
if (res < 1) {
ast_log(LOG_NOTICE, "Selected timed out/errored out with %d\n", res);
return -1;

View File

@ -55,6 +55,7 @@ ASTERISK_FILE_VERSION(__FILE__, "$Revision$")
#include "asterisk/stringfields.h"
#include "asterisk/abstract_jb.h"
#include "asterisk/musiconhold.h"
#include "asterisk/poll-compat.h"
/*! Global jitterbuffer configuration - by default, jb is disabled */
static struct ast_jb_conf default_jbconf = {

View File

@ -6248,7 +6248,7 @@ static int get_input(struct skinnysession *s)
fds[0].fd = s->fd;
fds[0].events = POLLIN;
fds[0].revents = 0;
res = poll(fds, 1, (keep_alive * 1100)); /* If nothing has happen, client is dead */
res = ast_poll(fds, 1, (keep_alive * 1100)); /* If nothing has happen, client is dead */
/* we add 10% to the keep_alive to deal */
/* with network delays, etc */
if (res < 0) {

149
configure vendored
View File

@ -4104,6 +4104,13 @@ case "${host_os}" in
fi
CPPFLAGS=-I/usr/local/include
LDFLAGS=-L/usr/local/lib
;;
darwin*)
cat >>confdefs.h <<\_ACEOF
#define AST_POLL_COMPAT 1
_ACEOF
;;
*)
ac_default_prefix=/usr
@ -11239,6 +11246,148 @@ fi
done
if test "${ac_cv_header_sys_poll_h+set}" = set; then
{ echo "$as_me:$LINENO: checking for sys/poll.h" >&5
echo $ECHO_N "checking for sys/poll.h... $ECHO_C" >&6; }
if test "${ac_cv_header_sys_poll_h+set}" = set; then
echo $ECHO_N "(cached) $ECHO_C" >&6
fi
{ echo "$as_me:$LINENO: result: $ac_cv_header_sys_poll_h" >&5
echo "${ECHO_T}$ac_cv_header_sys_poll_h" >&6; }
else
# Is the header compilable?
{ echo "$as_me:$LINENO: checking sys/poll.h usability" >&5
echo $ECHO_N "checking sys/poll.h usability... $ECHO_C" >&6; }
cat >conftest.$ac_ext <<_ACEOF
/* confdefs.h. */
_ACEOF
cat confdefs.h >>conftest.$ac_ext
cat >>conftest.$ac_ext <<_ACEOF
/* end confdefs.h. */
$ac_includes_default
#include <sys/poll.h>
_ACEOF
rm -f conftest.$ac_objext
if { (ac_try="$ac_compile"
case "(($ac_try" in
*\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
*) ac_try_echo=$ac_try;;
esac
eval "echo \"\$as_me:$LINENO: $ac_try_echo\"") >&5
(eval "$ac_compile") 2>conftest.er1
ac_status=$?
grep -v '^ *+' conftest.er1 >conftest.err
rm -f conftest.er1
cat conftest.err >&5
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); } && {
test -z "$ac_c_werror_flag" ||
test ! -s conftest.err
} && test -s conftest.$ac_objext; then
ac_header_compiler=yes
else
echo "$as_me: failed program was:" >&5
sed 's/^/| /' conftest.$ac_ext >&5
ac_header_compiler=no
fi
rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
{ echo "$as_me:$LINENO: result: $ac_header_compiler" >&5
echo "${ECHO_T}$ac_header_compiler" >&6; }
# Is the header present?
{ echo "$as_me:$LINENO: checking sys/poll.h presence" >&5
echo $ECHO_N "checking sys/poll.h presence... $ECHO_C" >&6; }
cat >conftest.$ac_ext <<_ACEOF
/* confdefs.h. */
_ACEOF
cat confdefs.h >>conftest.$ac_ext
cat >>conftest.$ac_ext <<_ACEOF
/* end confdefs.h. */
#include <sys/poll.h>
_ACEOF
if { (ac_try="$ac_cpp conftest.$ac_ext"
case "(($ac_try" in
*\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
*) ac_try_echo=$ac_try;;
esac
eval "echo \"\$as_me:$LINENO: $ac_try_echo\"") >&5
(eval "$ac_cpp conftest.$ac_ext") 2>conftest.er1
ac_status=$?
grep -v '^ *+' conftest.er1 >conftest.err
rm -f conftest.er1
cat conftest.err >&5
echo "$as_me:$LINENO: \$? = $ac_status" >&5
(exit $ac_status); } >/dev/null && {
test -z "$ac_c_preproc_warn_flag$ac_c_werror_flag" ||
test ! -s conftest.err
}; then
ac_header_preproc=yes
else
echo "$as_me: failed program was:" >&5
sed 's/^/| /' conftest.$ac_ext >&5
ac_header_preproc=no
fi
rm -f conftest.err conftest.$ac_ext
{ echo "$as_me:$LINENO: result: $ac_header_preproc" >&5
echo "${ECHO_T}$ac_header_preproc" >&6; }
# So? What about this header?
case $ac_header_compiler:$ac_header_preproc:$ac_c_preproc_warn_flag in
yes:no: )
{ echo "$as_me:$LINENO: WARNING: sys/poll.h: accepted by the compiler, rejected by the preprocessor!" >&5
echo "$as_me: WARNING: sys/poll.h: accepted by the compiler, rejected by the preprocessor!" >&2;}
{ echo "$as_me:$LINENO: WARNING: sys/poll.h: proceeding with the compiler's result" >&5
echo "$as_me: WARNING: sys/poll.h: proceeding with the compiler's result" >&2;}
ac_header_preproc=yes
;;
no:yes:* )
{ echo "$as_me:$LINENO: WARNING: sys/poll.h: present but cannot be compiled" >&5
echo "$as_me: WARNING: sys/poll.h: present but cannot be compiled" >&2;}
{ echo "$as_me:$LINENO: WARNING: sys/poll.h: check for missing prerequisite headers?" >&5
echo "$as_me: WARNING: sys/poll.h: check for missing prerequisite headers?" >&2;}
{ echo "$as_me:$LINENO: WARNING: sys/poll.h: see the Autoconf documentation" >&5
echo "$as_me: WARNING: sys/poll.h: see the Autoconf documentation" >&2;}
{ echo "$as_me:$LINENO: WARNING: sys/poll.h: section \"Present But Cannot Be Compiled\"" >&5
echo "$as_me: WARNING: sys/poll.h: section \"Present But Cannot Be Compiled\"" >&2;}
{ echo "$as_me:$LINENO: WARNING: sys/poll.h: proceeding with the preprocessor's result" >&5
echo "$as_me: WARNING: sys/poll.h: proceeding with the preprocessor's result" >&2;}
{ echo "$as_me:$LINENO: WARNING: sys/poll.h: in the future, the compiler will take precedence" >&5
echo "$as_me: WARNING: sys/poll.h: in the future, the compiler will take precedence" >&2;}
( cat <<\_ASBOX
## ------------------------------- ##
## Report this to www.asterisk.org ##
## ------------------------------- ##
_ASBOX
) | sed "s/^/$as_me: WARNING: /" >&2
;;
esac
{ echo "$as_me:$LINENO: checking for sys/poll.h" >&5
echo $ECHO_N "checking for sys/poll.h... $ECHO_C" >&6; }
if test "${ac_cv_header_sys_poll_h+set}" = set; then
echo $ECHO_N "(cached) $ECHO_C" >&6
else
ac_cv_header_sys_poll_h=$ac_header_preproc
fi
{ echo "$as_me:$LINENO: result: $ac_cv_header_sys_poll_h" >&5
echo "${ECHO_T}$ac_cv_header_sys_poll_h" >&6; }
fi
if test $ac_cv_header_sys_poll_h = yes; then
:
else
cat >>confdefs.h <<\_ACEOF
#define AST_POLL_COMPAT 1
_ACEOF
fi
# Check whether --enable-largefile was given.
if test "${enable_largefile+set}" = set; then
enableval=$enable_largefile;

View File

@ -44,6 +44,9 @@ case "${host_os}" in
CPPFLAGS=-I/usr/local/include
LDFLAGS=-L/usr/local/lib
;;
darwin*)
AC_DEFINE([AST_POLL_COMPAT], 1, [Define to 1 if internal poll should be used.])
;;
*)
ac_default_prefix=/usr
if test ${prefix} = '/usr' || test ${prefix} = 'NONE'; then
@ -304,6 +307,10 @@ AC_CHECK_HEADERS([arpa/inet.h fcntl.h inttypes.h libintl.h limits.h locale.h mal
AC_CHECK_HEADERS([winsock.h winsock2.h])
AC_CHECK_HEADER([sys/poll.h],
[],
AC_DEFINE([AST_POLL_COMPAT], 1, [Define to 1 if internal poll should be used.]))
AC_SYS_LARGEFILE
# Checks for typedefs, structures, and compiler characteristics.

View File

@ -7,6 +7,9 @@
/* Define to 1 if internal poll should be used. */
#undef AST_POLL_COMPAT
/* Define to 1 if the `closedir' function returns void instead of `int'. */
#undef CLOSEDIR_VOID

View File

@ -125,11 +125,7 @@ References:
#include "asterisk/abstract_jb.h"
#ifdef HAVE_SYS_POLL_H
#include <sys/poll.h>
#else
#include "asterisk/poll-compat.h"
#endif
#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {

View File

@ -23,11 +23,7 @@
#ifndef _ASTERISK_IO_H
#define _ASTERISK_IO_H
#ifdef HAVE_SYS_POLL_H
#include <sys/poll.h> /* For POLL* constants */
#else
#include "asterisk/poll-compat.h"
#endif
#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {

View File

@ -76,8 +76,16 @@
original.
\*---------------------------------------------------------------------------*/
#ifndef _POLL_EMUL_H_
#define _POLL_EMUL_H_
#ifndef __AST_POLL_COMPAT_H
#define __AST_POLL_COMPAT_H
#ifndef AST_POLL_COMPAT
#include <sys/poll.h>
#define ast_poll(a, b, c) poll(a, b, c)
#else /* AST_POLL_COMPAT */
#define POLLIN 0x01
#define POLLPRI 0x02
@ -86,26 +94,24 @@
#define POLLHUP 0x10
#define POLLNVAL 0x20
struct pollfd
{
struct pollfd {
int fd;
short events;
short revents;
};
#ifdef __cplusplus
extern "C"
{
extern "C" {
#endif
#if (__STDC__ > 0) || defined(__cplusplus)
extern int poll (struct pollfd *pArray, unsigned long n_fds, int timeout);
#else
extern int poll();
#endif
#define ast_poll(a, b, c) ast_internal_poll(a, b, c)
int ast_internal_poll(struct pollfd *pArray, unsigned long n_fds, int timeout);
#ifdef __cplusplus
}
#endif
#endif /* _POLL_EMUL_H_ */
#endif /* AST_POLL_COMPAT */
#endif /* __AST_POLL_COMPAT_H */

View File

@ -29,7 +29,7 @@ OBJS= tcptls.o io.o sched.o logger.o frame.o loader.o config.o channel.o \
strcompat.o threadstorage.o dial.o event.o adsistub.o audiohook.o \
astobj2.o hashtab.o global_datastores.o version.o \
features.o taskprocessor.o timing.o datastore.o xml.o xmldoc.o \
strings.o bridging.o
strings.o bridging.o poll.o
# we need to link in the objects statically, not as a library, because
# otherwise modules will not have them available if none of the static
@ -44,14 +44,6 @@ AST_LIBS += $(OPENSSL_LIB)
AST_LIBS += $(BKTR_LIB)
AST_LIBS += $(LIBXML2_LIB)
ifeq ($(POLL_AVAILABLE),)
OBJS+=poll.o
else
ifneq ($(findstring darwin,$(OSARCH)),)
OBJS+=poll.o
endif
endif
ifneq ($(findstring $(OSARCH), linux-gnu uclinux linux-uclibc linux-gnueabi ),)
ifneq ($(findstring LOADABLE_MODULES,$(MENUSELECT_CFLAGS)),)
AST_LIBS+=-ldl

View File

@ -137,6 +137,7 @@ int daemon(int, int); /* defined in libresolv of all places */
#include "asterisk/dsp.h"
#include "asterisk/buildinfo.h"
#include "asterisk/xmldoc.h"
#include "asterisk/poll-compat.h"
#include "asterisk/doxyref.h" /* Doxygen documentation */
@ -1213,7 +1214,7 @@ static void *netconsole(void *vconsole)
fds[1].events = POLLIN;
fds[1].revents = 0;
res = poll(fds, 2, -1);
res = ast_poll(fds, 2, -1);
if (res < 0) {
if (errno != EINTR)
ast_log(LOG_WARNING, "poll returned < 0: %s\n", strerror(errno));
@ -1266,7 +1267,7 @@ static void *listener(void *unused)
return NULL;
fds[0].fd = ast_socket;
fds[0].events = POLLIN;
s = poll(fds, 1, -1);
s = ast_poll(fds, 1, -1);
pthread_testcancel();
if (s < 0) {
if (errno != EINTR)
@ -2081,7 +2082,7 @@ static int ast_el_read_char(EditLine *editline, char *cp)
fds[1].events = POLLIN;
max++;
}
res = poll(fds, max, -1);
res = ast_poll(fds, max, -1);
if (res < 0) {
if (sig_flags.need_quit)
break;
@ -2649,7 +2650,7 @@ static void ast_remotecontrol(char *data)
fds.fd = ast_consock;
fds.events = POLLIN;
fds.revents = 0;
while (poll(&fds, 1, 500) > 0) {
while (ast_poll(&fds, 1, 500) > 0) {
char buffer[512] = "", *curline = buffer, *nextline;
int not_written = 1;
@ -3013,7 +3014,7 @@ static void *monitor_sig_flags(void *unused)
for (;;) {
struct pollfd p = { sig_alert_pipe[0], POLLIN, 0 };
int a;
poll(&p, 1, -1);
ast_poll(&p, 1, -1);
if (sig_flags.need_reload) {
sig_flags.need_reload = 0;
ast_module_reload(NULL);

View File

@ -2029,12 +2029,12 @@ struct ast_channel *ast_waitfor_nandfds(struct ast_channel **c, int n, int *fds,
int kbrms = rms;
if (kbrms > 600000)
kbrms = 600000;
res = poll(pfds, max, kbrms);
res = ast_poll(pfds, max, kbrms);
if (!res)
rms -= kbrms;
} while (!res && (rms > 0));
} else {
res = poll(pfds, max, rms);
res = ast_poll(pfds, max, rms);
}
for (x = 0; x < n; x++)
ast_clear_flag(c[x], AST_FLAG_BLOCKING);

View File

@ -272,8 +272,9 @@ int ast_io_wait(struct io_context *ioc, int howlong)
DEBUG(ast_debug(1, "ast_io_wait()\n"));
if ((res = poll(ioc->fds, ioc->fdcnt, howlong)) <= 0)
if ((res = ast_poll(ioc->fds, ioc->fdcnt, howlong)) <= 0) {
return res;
}
/* At least one event tripped */
origcnt = ioc->fdcnt;

View File

@ -71,6 +71,8 @@
Includes
\*---------------------------------------------------------------------------*/
#include "asterisk.h"
#include <unistd.h> /* standard Unix definitions */
#include <sys/types.h> /* system types */
#include <sys/time.h> /* time definitions */
@ -79,6 +81,8 @@
#include "asterisk/poll-compat.h" /* this package */
#ifdef AST_POLL_COMPAT
/*---------------------------------------------------------------------------*\
Macros
\*---------------------------------------------------------------------------*/
@ -87,7 +91,6 @@
#define MAX(a,b) ((a) > (b) ? (a) : (b))
#endif
/*---------------------------------------------------------------------------*\
Private Functions
\*---------------------------------------------------------------------------*/
@ -203,7 +206,7 @@ static struct timeval *map_timeout
return pResult;
}
static void map_select_results
#if __STDC__ > 0
(struct pollfd *pArray,
@ -246,22 +249,12 @@ static void map_select_results
return;
}
/*---------------------------------------------------------------------------*\
Public Functions
\*---------------------------------------------------------------------------*/
int poll
#if __STDC__ > 0
(struct pollfd *pArray, unsigned long n_fds, int timeout)
#else
(pArray, n_fds, timeout)
struct pollfd *pArray;
unsigned long n_fds;
int timeout;
#endif
int ast_internal_poll(struct pollfd *pArray, unsigned long n_fds, int timeout)
{
fd_set read_descs; /* input file descs */
fd_set write_descs; /* output file descs */
@ -295,3 +288,5 @@ int poll
return ready_descriptors;
}
#endif /* AST_POLL_COMPAT */

View File

@ -1054,7 +1054,7 @@ int ast_wait_for_input(int fd, int ms)
memset(pfd, 0, sizeof(pfd));
pfd[0].fd = fd;
pfd[0].events = POLLIN|POLLPRI;
return poll(pfd, 1, ms);
return ast_poll(pfd, 1, ms);
}
static int ast_wait_for_output(int fd, int timeoutms)
@ -1068,7 +1068,7 @@ static int ast_wait_for_output(int fd, int timeoutms)
int elapsed = 0;
/* poll() until the fd is writable without blocking */
while ((res = poll(&pfd, 1, timeoutms - elapsed)) <= 0) {
while ((res = ast_poll(&pfd, 1, timeoutms - elapsed)) <= 0) {
if (res == 0) {
/* timed out. */
ast_log(LOG_NOTICE, "Timed out trying to write\n");

View File

@ -814,7 +814,7 @@ static enum agi_result launch_netscript(char *agiurl, char *argv[], int *fds, in
pfds[0].fd = s;
pfds[0].events = POLLOUT;
while ((res = poll(pfds, 1, MAX_AGI_CONNECT)) != 1) {
while ((res = ast_poll(pfds, 1, MAX_AGI_CONNECT)) != 1) {
if (errno != EINTR) {
if (!res) {
ast_log(LOG_WARNING, "FastAGI connection to '%s' timed out after MAX_AGI_CONNECT (%d) milliseconds.\n",